# coding: utf-8

"""
    Fingerprint Pro Server API

    Fingerprint Pro Server API allows you to get information about visitors and about individual events in a server environment. It can be used for data exports, decision-making, and data analysis scenarios. Server API is intended for server-side usage, it's not intended to be used from the client side, whether it's a browser or a mobile device.   # noqa: E501

    OpenAPI spec version: 3
    Contact: support@fingerprint.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import Dict, List  # noqa: F401
from fingerprint_pro_server_api_sdk.base_model import BaseModel
from fingerprint_pro_server_api_sdk.models.products_response import ProductsResponse
from fingerprint_pro_server_api_sdk.models.product_error import ProductError


class EventResponse(BaseModel):
    """
    Contains results from all activated products - Fingerprint Pro, Bot Detection, and others.

    NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'products': 'ProductsResponse',
        'error': 'ProductError'
    }

    attribute_map = {
        'products': 'products',
        'error': 'error'
    }

    def __init__(self, products=None, error=None):  # noqa: E501
        """EventResponse - a model defined in Swagger"""  # noqa: E501
        self._products = None
        self._error = None
        self.discriminator = None
        self.products = products
        if error is not None:
            self.error = error

    @property
    def products(self) -> ProductsResponse:
        """Gets the products of this EventResponse.  # noqa: E501


        :return: The products of this EventResponse.  # noqa: E501
        """
        return self._products

    @products.setter
    def products(self, products: ProductsResponse):
        """Sets the products of this EventResponse.


        :param products: The products of this EventResponse.  # noqa: E501
        """
        if products is None:
            raise ValueError("Invalid value for `products`, must not be `None`")  # noqa: E501

        self._products = products

    @property
    def error(self) -> ProductError:
        """Gets the error of this EventResponse.  # noqa: E501


        :return: The error of this EventResponse.  # noqa: E501
        """
        return self._error

    @error.setter
    def error(self, error: ProductError):
        """Sets the error of this EventResponse.


        :param error: The error of this EventResponse.  # noqa: E501
        """

        self._error = error

